<?php


namespace OrganizationsManagement\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;


class Cliente
{
    public function findAllClientes(DTO\Request $request, DTO\Response $response){
        try {
            $page = 0; //$request->getParameter('page');
            $pageSize = 0; //|| $request->getParameter('pageSize');
            $data = InstanceProvider::getService()->getCliente()->findAllClientes($page, $pageSize);
            $response->addDataSet(new DataSet('clientes', $data));
        } catch (\Exception $ex){
            $response->setError(new Error($ex->getMessage(), $ex->getCode()));
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
        }
    }

    public function findClientesPorOperador(DTO\Request $request, DTO\Response $response)
    {
        try {
            $cdOperador = $request->getParameter('cdoperador');
            $operators = InstanceProvider::getService()->getCliente()->findClientesPorOperador($cdOperador);
            $response->addDataSet(new DataSource\DataSet('clientesPorOperador', $operators));
        } catch (\Exception $ex){
            $response->setError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function findRelacionarClientesComOperador(DTO\Request $request, DTO\Response $response)
    {
        try {
            $cdoperador = $request->getParameter('cdoperador');
            $operators = InstanceProvider::getService()->getCliente()->findRelacionarClientesComOperador($cdoperador);
            $response->addDataSet(new DataSource\DataSet('relacionarClientesComOperador', $operators));
        } catch (\Exception $ex){
            $response->setError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function saveRelacionarClientesComOperador(DTO\Request $request, DTO\Response $response)
    {
        try {
            $clienteService = InstanceProvider::getService()->getCliente();
            $clientes = $request->getParameter('clientes');
            $cdoperador = $request->getParameter('cdoperador');
            $idtpoperclie = $request->getParameter('idtpoperclie');
            $nrpriopercli = $request->getParameter('nrpriopercli');
            $clienteService->saveRelacionarClientesComOperador($clientes, $cdoperador, $idtpoperclie, $nrpriopercli);
        } catch (\Exception $ex){
            $response->setCriticalError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function deleteRelacionarClientesComOperador(DTO\Request $request, DTO\Response $response)
    {
        try {
            $clienteService = InstanceProvider::getService()->getCliente();
            $clientes = $request->getParameters();
            $clienteService->deleteRelacionarClientesComOperador($clientes);
        } catch (\Exception $ex) {
            $response->setCriticalError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }
}