<?php
namespace OrganizationsManagement\Util\Instance;

use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;
use Teknisa\Model\Teknisa\Repositories as TeknisaRepositories;
use Teknisa\Model\Services\Repositories as ServicesRepositories;
use Zeedhi\Framework\DependencyInjection\InstanceManager;


class Repository {

    /** @return  Repository */
    public static function getInstance()
    {
        return new static();
    }

    
    public function getNotificationServices()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServicoNotificacao');
    }
    
    public function getNotificationServicesApp()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServicoNotifAppParam');
    }
    
    public function getNotificationServicesDev()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServicoNotifDispParam');
    }
    
    public function getNotificationParametersProdOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServicoNotifProdutoOrg');
    }
    
    public function getNotificationParametersProd()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServicoNotifProduto');
    }
    
    public function getNotificationParametersAppProdOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServNotAppParamProdOrg');
    }
    
    public function getNotificationParametersAppProd()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmServNotAppParamProd');
    }

    /** @return TeknisaRepositories\OmProdutoOrg */
    public function getOmProdutoOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProdutoOrg');
    }

    /** @return TeknisaRepositories\OmProduto */
    public function getOmProduto()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProduto');
    }

    /** @return TeknisaRepositories\OmProdutoElemento */
    public function getOmProdutoElemento()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProdutoElemento');
    }

    /** @return TeknisaRepositories\OmProdutoRepositorio */
    public function getOmProdutoRepositorio()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProdutoRepositorio');
    }

    /** @return \Teknisa\Model\Geral\Repositories\Produto */
    public function getProduto()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Produto');
    }

    /** @return TeknisaRepositories\OmConfigMedidaVariavel */
    public function getOmConfigMedidaVariavel()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmConfigMedidaVariavel');
    }

    /** @return TeknisaRepositories\OmConfigColeta */
    public function getOmConfigColeta()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmConfigColeta');
    }

    /** @return TeknisaRepositories\OmConfigColetaOrg */
    public function getOmConfigColetaOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmConfigColetaOrg');
    }

    /** @return TeknisaRepositories\OmProdutoOrgVersao */
    public function getOmProdutoOrgVersao()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProdutoOrgVersao');
    }

    public function getPerfilAcesso()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Perfilacesso');
    }
    /** @return \Teknisa\Model\Geral\Repositories\Operador */
    public function getOperador()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Operador');
    }

     /** @return \Teknisa\Model\Geral\Repositories\Organizacao */
    public function getOrganizacao()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Organizacao');
    }
    /* @return \Teknisa\Model\Geral\Repositories\Cliente */
    public function getCliente()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Cliente');
    }

    /**
     * @param EntityManager|null $entityManager
     * @return \Teknisa\Model\Geral\Repositories\Estruturam
     */
    public function getEstruturam(EntityManager $entityManager = null)
    {
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getRepository(Utilities::GERAL_ENTITY_DIR . 'Estruturam');
    }

    /**
     * @param EntityManager|null $entityManager
     * @return \Teknisa\Model\Geral\Repositories\Parcnegocio
     */
    public function getParcnegocio(EntityManager $entityManager = null)
    {
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();
        return $entityManager->getRepository(Utilities::GERAL_ENTITY_DIR . 'Parcnegocio');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\BudgetItemFctItemorcamento */
    public function getBudgetItemFctItemorcamento()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'BudgetItemFctItemorcamento');
    }
    
    /** @return \Teknisa\Model\Teknisa\Repositories\ItemorcaprodFctItemorcamento */
    public function getItemprodorcaFctItemorcamento()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'ItemorcaprodFctItemorcamento');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\OmIntegracoes */
    public function getOmIntegracoes()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmIntegracoes');
    }
    public function getFctParametrogeral()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::SERVICES_ENTITY_DIR . 'FctParametrogeral');
    }
    /** @return \Teknisa\Model\Services\Repositories\FctServicoorca */
    public function getFctServicoOrca()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::SERVICES_ENTITY_DIR . 'FctServicoorca');
    }
    /** @return \Teknisa\Model\Services\Repositories\FctContrato */
    public function getFctContrato()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::SERVICES_ENTITY_DIR . 'FctContrato');
    }
    /** @return \Teknisa\Model\Teknisa\Repositories\OmAtualizacaoEstrutura */
    public function getOmAtualizacaoEstrutura()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmAtualizacaoEstrutura');
    }
    /** @return \Teknisa\Model\Teknisa\Repositories\OmAtualizacaoEstruturaOrg */
    public function getOmAtualizacaoEstruturaOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmAtualizacaoEstruturaOrg');
    }
    /** @return \Teknisa\Model\Teknisa\Repositories\OmComandoEstrutura */
    public function getOmComandoEstrutura()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmComandoEstrutura');
    }
    /** @return \Teknisa\Model\Teknisa\Repositories\OmComandoEstruturaUrl */
    public function getOmComandoEstruturaUrl()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmComandoEstruturaUrl');
    }

    /** @return ServicesRepositories\FctTipomedidaserv */
    public function getFctTipomedidaserv()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::SERVICES_ENTITY_DIR . 'FctTipomedidaserv');
    }

    public function getContato()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CRM_ENTITY_DIR . 'Contato');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Propostalinp */
    public function getPropostalinp()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Propostalinp');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Moticont */
    public static function getMoticont()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Moticont');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Contratolinp */
    public static function getContratolinp()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Contratolinp');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Sistcontlinp */
    public static function getSistcontlinp()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Sistcontlinp');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Valorlinp */
    public static function getValorlinp()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Valorlinp');
    }

    /** @return \Teknisa\Model\Avaliacao\Repositories\Assunto */
    public static function getAssunto()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::AVALIACAO_ENTITY_DIR . 'Assunto');
    }

    /**
     * @return \OrganizationsManagement\Repository\ServerMnemonic
     * @throws \Exception
     */
    public function getServerMnemonic()
    {
        return InstanceManager::getInstance()->getService('serverMnemonicRepository');
    }

    /**
     * @return \OrganizationsManagement\Repository\Organization
     * @throws \Exception
     */
    public function getOrganization()
    {
        return InstanceManager::getInstance()->getService('organizationRepository');
    }

    /**
     * @return \OrganizationsManagement\Repository\OmParcnegocio
     * @throws \Exception
     */
    public function getOmParcnegocio()
    {
        return InstanceManager::getInstance()->getService('OmParcnegocio');
    }

    /**
     * @return \OrganizationsManagement\Repository\ScoreReport
     * @throws \Exception
     */
    public function getScoreReport()
    {
        return InstanceManager::getInstance()->getService('scoreReportRepository');
    }

    /** @return \Teknisa\Model\Geral\Repositories\Pais */
    public function getPais()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Pais');
    }

    /** @return \Teknisa\Model\Faturamento\Repositories\Parcliefas */
    public function getParcliefas()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::FATURAMENTO_ENTITY_DIR . 'Parcliefas');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\OmColetaMedidaVariavel */
    public static function getOmColetaMedidaVariavel()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmColetaMedidaVariavel');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Soliserv */
    public static function getSoliserv()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Soliserv');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Logfasetram */
    public static function getLogfasetram()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Logfasetram');
    }

    /** @return TeknisaRepositories\OmParamOrgDefault */
    public static function getOmParamOrgDefault()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmParamOrgDefault');
    }

    /** @return TeknisaRepositories\OmParamOrg */
    public static function getOmParamOrg()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmParamOrg');
    }

    /** @return TeknisaRepositories\OmProdutoOrgElementoContrato */
    public static function getOmProdutoOrgElementoContrato()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'OmProdutoOrgElementoContrato');
    }

    /** @return TeknisaRepositories\Operclie */
    public static function getOperclie()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Operclie');
    }
}