const state = {
    load: false,
    notification: {
        isVisible: false,
        text: '',
        color: 'success'
    }
};

const mutations = {
    SET_LOAD: (_state: any, payload: boolean) => {
        state.load = payload;
    },
    setNotification: (_state: any, payload: string) => {
        _state.notification = payload;
    },
    closeNotification: (_state: any) => {
        _state.notification.isVisible = false;
    }
};

const actions = {
    setLoad: (context: any, payload: boolean) => {
        context.commit('SET_LOAD', payload);
    },
    setNotification: (context: any, payload: any) => {
        context.commit('setNotification', payload);
    },
    closeNotification: (context: any) => {
        context.commit('closeNotification');
    }
};

const getters = {
    getLoad: (_state: any) => _state.load,
    getNotificationColor: (_state: any) => _state.notification.color,
    getNotificationVisible: (_state: any) => _state.notification.isVisible,
    getNotificationText: (_state: any) => _state.notification.text,
    getNotification: (_state: any) => _state.notification
};

export default {
    namespaced: true,
    state,
    mutations,
    actions,
    getters
};
